# When running this simple script through pylint, it breaks with
# the exception
#
# > TypeError: '_Yes' object is not iterable
#
# (see log file, attached to the logilab_astng issue)
#
# However, the simple call "python BuilderTests.py" yields the
# expected output
#
# > Preparing Hi
# > Preparing there
# > Building Hi
# > Building there
#


class Target:
    def __init__(self, name):
        self.name = name

    def prepare(self):
        print "Preparing %s" % self.name

    def build(self):
        print "Building %s" % self.name

def Builder(**kw):
    composite = None
    result = BuilderBase(**kw)

    if not composite is None:
        result = CompositeBuilder(result, composite)

    return result

class BuilderBase(object):
    def __init__(self):
        pass

    def __call__(self):
        return (Target("Hi"), Target("there"))

class Delegate(object):
    """A Python Descriptor class that delegates attribute fetches
    to an underlying wrapped subject of a Proxy.  Typical use:

        class Foo(Proxy):
            __str__ = Delegate('__str__')
    """
    def __init__(self, attribute):
        self.attribute = attribute
    def __get__(self, obj, cls):
        if isinstance(obj, cls):
            return getattr(obj._subject, self.attribute)
        else:
            return self

class CompositeBuilder(object):
    def __init__(self):
        pass

    #######################################################
    # This appears to be the offending line that triggers
    # the error message...
    #######################################################
    __call__ = Delegate('__call__')

def main():
    builder = Builder()
    tgts = builder()
    for t in tgts: t.prepare()
    tgts[0].build()
    tgts[1].build()
        
if __name__ == "__main__":
    main()

